# Detect the distribution in use
%global __despace head -n 1 | tr -d '[:space:]' | sed -e 's/[(].*[)]//g'
%global __lower4 cut -c 1-4 | tr '[:upper:]' '[:lower:]'
%global __distfile %([ -f /etc/SuSE-release ] && echo /etc/SuSE-release || echo /etc/redhat-release)
%global __distinit %(sed -e 's/ release .*//' -e 's/\\([A-Za-z]\\)[^ ]*/\\1/g' %{__distfile} | %{__despace} | %{__lower4})
%global __distvers %(sed -e 's/.* release \\([^. ]*\\).*/\\1/' %{__distfile} | %{__despace})
# Identify CentOS Linux and Scientific Linux as rhel
%if "%{__distinit}" == "c" || "%{__distinit}" == "cl" || "%{__distinit}" == "sl" || "%{__distinit}" == "sls"
%global __distinit rhel
%endif
# Dist tag for Fedora is still "fc"
%if "%{__distinit}" == "f"
%global __distinit fc
%endif

# We need to patch the test suite if we have an old version of Test::More
%global old_test_more %(perl -MTest::More -e 'print (($Test::More::VERSION < 0.96) ? 1 : 0);' 2>/dev/null || echo 0)

# Pure-perl implementation requires Hash::Util::FieldHash, which requires perl ≥ 5.10
%global xsonly %(perl -e 'print $] >= 5.010 ? 0 : 1;')

#TODO: BR: perl(Test::Pod::No404s) when available

Name:		perl-B-Hooks-EndOfScope
Version:	0.13
Release:	1.%{__distinit}%{__distvers}
License:	GPL+ or Artistic
Group:		Development/Libraries
Summary:	Execute code after scope compilation finishes
URL:		http://search.cpan.org/dist/B-Hooks-EndOfScope/
Source0:	http://search.cpan.org/CPAN/authors/id/E/ET/ETHER/B-Hooks-EndOfScope-%{version}.tar.gz
Patch1:		B-Hooks-EndOfScope-0.13-old-Test::More.patch
BuildRoot:	%{_tmppath}/%{name}-%{version}-%{release}-root-%(id -nu)
BuildArch:	noarch
# Build
BuildRequires:	perl(ExtUtils::CBuilder) >= 0.26
BuildRequires:	perl(ExtUtils::MakeMaker)
# Module
# note: Variable::Magic only needed (version ≥ 0.48) by XS version
#	base, constant, Hash::Util::FieldHash and Scalar::Util only needed by PP version
%if ! %{xsonly}
BuildRequires:	perl(base)
BuildRequires:	perl(constant)
BuildRequires:	perl(Hash::Util::FieldHash)
BuildRequires:	perl(Scalar::Util)
%endif
BuildRequires:	perl(Module::Implementation) >= 0.05
BuildRequires:	perl(Module::Runtime) >= 0.012
BuildRequires:	perl(Sub::Exporter::Progressive) >= 0.001006
BuildRequires:	perl(Variable::Magic) >= 0.48
# Test suite
BuildRequires:	perl(CPAN::Meta)
BuildRequires:	perl(CPAN::Meta::Requirements)
BuildRequires:	perl(Devel::Hide) >= 0.0007
BuildRequires:	perl(Test::More)
# Release tests
%if 0%{!?perl_bootstrap:1} && ! %{xsonly}
BuildRequires:	perl(Pod::Coverage::TrustPod)
BuildRequires:	perl(Test::CPAN::Meta)
BuildRequires:	perl(Test::EOL)
BuildRequires:	perl(Test::Kwalitee)
BuildRequires:	perl(Test::MinimumVersion)
BuildRequires:	perl(Test::Mojibake)
BuildRequires:	perl(Test::NoTabs)
BuildRequires:	perl(Test::Pod) >= 1.41
BuildRequires:	perl(Test::Pod::Coverage) >= 1.08
BuildRequires:	perl(Test::Portability::Files)
BuildRequires:	perl(Test::Spelling), hunspell-en
BuildRequires:	perl(Test::Version)
# Test::CPAN::Changes and Test::Vars only available if we have Perl 5.10.0 onwards
%if %(perl -e 'print $] >= 5.010000 ? 1 : 0;')
BuildRequires:	perl(Test::CPAN::Changes)
BuildRequires:	perl(Test::Vars)
%endif
%endif
# Runtime
Requires:	perl(:MODULE_COMPAT_%(eval "`perl -V:version`"; echo $version))
Requires:	perl(Module::Implementation) >= 0.05
Requires:	perl(Module::Runtime) >= 0.012
Requires:	perl(Variable::Magic) >= 0.48

%description
This module allows you to execute code when Perl has finished compiling the
surrounding scope.

%prep
%setup -q -n B-Hooks-EndOfScope-%{version}

# Need to tweak the test suite if we have Test::More < 0.88
%if %{old_test_more}
%patch1
%endif

# Filter pure-perl requires/provides where we can only support the XS version
%if %{xsonly}
%global reqfilt /bin/sh -c "%{__perl_requires} | grep -Ev '^perl[(](base|constant|Hash::Util::FieldHash|Scalar::Util|Tie::Hash)[)]'"
%define __perl_requires %{reqfilt}
%global provfilt /bin/sh -c "%{__perl_provides} | grep -Ev '^perl[(]B::Hooks::EndOfScope::PP[)]'"
%define __perl_provides %{provfilt}
%endif

%build
perl Makefile.PL INSTALLDIRS=vendor
make %{?_smp_mflags}

%install
rm -rf %{buildroot}
make pure_install DESTDIR=%{buildroot}
find %{buildroot} -type f -name .packlist -exec rm -f {} ';'
%{_fixperms} %{buildroot}

%check
# AUTHOR_TESTING and extra tests explicitly test pure-perl version
%if ! %{xsonly}
export AUTHOR_TESTING=1
%endif
make test
%if 0%{!?perl_bootstrap:1} && ! %{xsonly}
make test TEST_FILES="$(echo $(find xt/ -name '*.t'))"
%endif

%clean
rm -rf %{buildroot}

%files
%defattr(-,root,root,-)
%doc Changes CONTRIBUTING LICENSE README README.md
%{perl_vendorlib}/B/
%{_mandir}/man3/B::Hooks::EndOfScope.3pm*
%{_mandir}/man3/B::Hooks::EndOfScope::PP.3pm*
%{_mandir}/man3/B::Hooks::EndOfScope::XS.3pm*

%changelog
* Wed Jan  8 2014 Paul Howarth <paul@city-fan.org> - 0.13-1
- Update to 0.13
  - Variable::Magic added as a runtime recommendation for greater visibility
    (CPAN RT#89245)
  - Fixed broken logic in compiler detection on older perls
  - Fixed inaccurate repository metadata
- This release by ETHER -> update source URL
- Drop Pod Coverage patch, no longer needed
- Update patch for building with old Test::More versions
- Don't run the release tests when bootstrapping

* Wed Dec  5 2012 Paul Howarth <paul@city-fan.org> - 0.12-1
- Update to 0.12
  - Complete pure-perl implementation in addition to the one based on
    Variable::Magic; you can specify the implementation explicitly by use-ing
    B::Hooks::EndOfScope::PP or B::Hooks::EndOfScope::XS, or by setting
    $ENV{B_HOOKS_ENDOFSCOPE_IMPLEMENTATION} to either 'XS' or 'PP'
  - Switch from using Sub::Exporter to the more conservative
    Sub::Exporter::Progressive
- Drop patch for building with old ExtUtils::MakeMaker versions, no longer
  needed
- Update patch for building with old Test::More versions
- Add new patch to fix POD coverage issues in new pure-perl implementation
- Build only the XS implementation if we don't have perl ≥ 5.10
- Only run the release tests if we've built both implementations, as the POD
  coverage test will die otherwise
- Classify buildreqs by usage
- This release by BOBTFISH -> update source URL
- BR: perl(ExtUtils::CBuilder) ≥ 0.26, perl(Devel::Hide) ≥ 0.0007,
  perl(Module::Implementation) ≥ 0.05 and perl(Module::Runtime) ≥ 0.012
- BR: perl(Sub::Exporter::Progressive) rather than perl(Sub::Exporter)
- BR: perl(base), perl(constant), perl(Hash::Util::FieldHash) and
  perl(Scalar::Util) if we're building the pure-perl implementation
- Filter requires/provides for unsupported implementations
- Add runtime dependencies for Module::Implementation and Module::Runtime

* Thu Jul 12 2012 Paul Howarth <paul@city-fan.org> - 0.11-2
- Don't need to remove empty directories from the buildroot
- Drop support for old distributions prior to FC-3:
  - Don't need to define %%{perl_vendorlib}
  - Use DESTDIR rather than PERL_INSTALL_ROOT

* Thu Feb 23 2012 Paul Howarth <paul@city-fan.org> - 0.11-1
- Update to 0.11 (a minor efficiency improvement)
- Bump perl(Variable::Magic) version requirement to 0.48

* Thu Feb 16 2012 Paul Howarth <paul@city-fan.org> - 0.10-1
- Update to 0.10 (stop propagating our magic through localisation)
- Package LICENSE file
- Update patch for building with old ExtUtils::MakeMaker versions
- Add patch to support building with Test::More < 0.89
- BR: perl(Test::EOL) and perl(Test::NoTabs) for additional test coverage

* Tue Jun 21 2011 Paul Howarth <paul@city-fan.org> - 0.09-2
- Rebuild for perl 5.14.1 in Rawhide
- Fix dist tag for CentOS 6 and Scientific Linux

* Fri Apr 29 2011 Paul Howarth <paul@city-fan.org> - 0.09-1
- Import from Fedora
- Update to 0.09 (improve distribution metadata)

* Tue Feb 08 2011 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 0.08-6
- Rebuilt for https://fedoraproject.org/wiki/Fedora_15_Mass_Rebuild

* Wed Dec 15 2010 Marcela Maslanova <mmaslano@redhat.com> - 0.08-5
- Rebuild to fix problems with vendorarch/lib (#661697)

* Thu Apr 29 2010 Marcela Maslanova <mmaslano@redhat.com> - 0.08-4
- Mass rebuild with perl-5.12.0

* Mon Dec  7 2009 Stepan Kasal <skasal@redhat.com> - 0.08-3
- Rebuild against perl 5.10.1

* Sat Jul 25 2009 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 0.08-2
- Rebuilt for https://fedoraproject.org/wiki/Fedora_12_Mass_Rebuild

* Sun May 17 2009 Chris Weyl <cweyl@alumni.drew.edu> - 0.08-1
- Auto-update to 0.08 (by cpan-spec-update 0.01)
- Altered br on perl(ExtUtils::MakeMaker) (0 => 6.42)
- Altered br on perl(Variable::Magic) (0.31 => 0.34)

* Sun Mar 08 2009 Chris Weyl <cweyl@alumni.drew.edu> 0.07-1
- Update to 0.07

* Thu Feb 26 2009 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 0.04-2
- Rebuilt for https://fedoraproject.org/wiki/Fedora_11_Mass_Rebuild

* Sat Nov 08 2008 Chris Weyl <cweyl@alumni.drew.edu> - 0.04-1
- Update for submission

* Sat Nov 08 2008 Chris Weyl <cweyl@alumni.drew.edu> - 0.04-0.1
- Initial RPM packaging
- Generated with cpan2dist (CPANPLUS::Dist::RPM version 0.0.5)
